import java.util.*;
import java.io.*;
import javax.sound.midi.*;


class cachord {
  int type;
  int length;                 
  int length2;
  int octave;

  static int STAY_AT_CENTER_OCTAVE = 0;
  static int SELECT_NEAR_CENTER_OCTAVE = 1;
  static int SELECT_BEST_OCTAVE = 2;
  static int select_chord_octave = SELECT_BEST_OCTAVE;

  cachord(int type,int length,int length2) {
    this.type = type;
    this.length = length;
    this.length2 = length2;
    this.octave = 0;
  }
  void selectbestoctave(cachord lastchord) {
    int bestscore = 1000000000;
    int bestoctave = 0;
    if (lastchord == null) {return;}
    if (select_chord_octave == STAY_AT_CENTER_OCTAVE){return;}
    //System.out.println("selectbestoctave");
    for (int o = -1;o <= 1;o++) {
      int n = chordnotesc.chords[lastchord.type][0] + (12 * lastchord.octave);
      int n2 = chordnotesc.chords[type][0] + (12 * o);
      int note_distance = n2-n;
      if (note_distance < 0) {note_distance = -note_distance;}
      int score = 0;
      if (n2 < chordnotesc.LOWEST_ROOT_NOTE) {
        score = chordnotesc.LOWEST_ROOT_NOTE - n2;
      }
      if (n2 > chordnotesc.HIGHEST_ROOT_NOTE) {
        score = n2 - chordnotesc.HIGHEST_ROOT_NOTE;
      }
      if (select_chord_octave == SELECT_NEAR_CENTER_OCTAVE) {
        score = score * 2;
      }
      score = score + note_distance;
      if (score < bestscore) {
        bestscore = score;
        bestoctave = o;
      }
    }
    octave = bestoctave;
  }
  String getname() {
    String str = "";
    for (int i = 0;i < chordnotesc.numnotesinchord;i++) {
      str = str + canote.getname2(chordnotesc.chords[type][i] + (octave * 12)) + " ";
    }
    return str;
  }
}
class canote {
  canote(int f,int l) {
    this.freq = f;
    this.length = l;
    this.am = 80;
    this.c = null;
    this.ins = 1;
  }
  canote(int f,int l,int am) {
    this.freq = f;
    this.length = l;
    this.am = am;
    this.c = null;
    this.ins = 1;
  }
  static String getname2(int f) {
    String str = notename[f % 12] + (f / 12);
    return str;
  }
  String getname() {
    return getname2(this.freq);
  }
  static String notename[] = {"c-","c#","d-","d#","e-","f-","f#","g-","g#","a-","a#","b-"};
  static int notefreq[] = {60,62,64,65,67,69,71,66};
  int freq;
  int length;
  int ins;
  int am;
  cachord c;
}

class chordnotesc {
    static int C = 60;
    static int D = 62;
    static int E = 64;
    static int F = 65;
    static int G = 67;
    static int A = 69;
    static int B = 71;
    static int LOWEST_ROOT_NOTE = C;
    static int HIGHEST_ROOT_NOTE = B;
    static int numchords = 7;
    static int maxchords = 27;
    static int numnotesinchord = 4;
    static int chords[][] = {{C,E,G,B},{D,F,A,C+12},{E,G,B,D+12},{F,A,C+12,E+12},
    {A,C+12,E+12,G+12},{G,B,D+12,F+12},{B,D+12,F+12,A+12},
    {D,F+1,A,C+12},{F+1,A,C+12,E+12},{G,B,D+12,F+13},{B,D+12,F+13,A+12},
    {A,C+13,E+12,G+12},{C+1,E,G,B},{D,F+1,A,C+13},{F+1,A,C+13,E+12},
    {E,G+1,B,D+12},{G+1,B,D+12,F+13},{A,C+13,E+12,G+13},{C+1,E,G+1,B},
    {B,D+13,F+13,A+12},{D+1,F+1,A,C+13},{E,G+1,B,D+13},{G+1,B,D+13,F+13},
    {F+1,A+1,C+13,E+12},{A+1,C+13,E+12,G+13},{B,D+13,F+13,A+13},{D+1,F+1,A+1,C+13}};
    static int chordindex[] = new int[maxchords];
    
}
class CA_Playerc {
  canote last_note = null;
  notelistc notelist;
  CA_Playerc() {
    notelist = new notelistc();
  }
  CA_Playerc(notelistc n) {
    notelist = n;
  }
  notelistc getnotelist() {
    return notelist;
  }
  void clearnotelist() {
    notelist.clear();
  }
  void play_row(boardc b,int y) {
    for (int x = 0;x < b.width;x++) {
      int sq = b.getsq(x,y);
      if (sq > 0) {
        int f = cellautorulec.cellnote[sq-1] + 60; 
        canote n = new canote(f,cellautoapp.min_note_length,80);
        if (last_note != null) {
          notelist.add(last_note);
        }
        last_note = n;
      } else {
        if (last_note != null) {
          last_note.length = last_note.length + cellautoapp.empty_cell_space_bonus;
        }
      }
    }
  }
  void play_last_note() {
    if (last_note != null) {
      notelist.add(last_note);
      last_note = null;
    }
  }
}

class notelistc extends Vector {
  cachord last_chord = null;
  int getsonglength() {
    return getnoteindexlength(0,size());
  }
  int getnoteindexlength(int i,int n) {
    int l = 0;
    for (int i2 = 0;i2 < n;i2++) {
      if ((i+i2) >= size()) {break;}
      canote n2 = (canote) get(i+i2);      
      l = l + n2.length;
    }
    return l;
  }
  int getchordscore(int offset,int t){
    byte noteinchord[] = new byte[12];
    for (int i2 = 0;i2 < 12;i2++) {
      noteinchord[i2] = 0;
    }
    for (int i = 0;i < chordnotesc.numnotesinchord;i++) {
      noteinchord[chordnotesc.chords[t][i] % 12] = 1;
    }
    int s = 0;
    for (int i = 0;i < 4;i++) {
      canote n = (canote) get(i+offset);
      if (noteinchord[n.freq % 12] == 1) {s = s + 1;}
    }
    s = s * 4;
    if (last_chord != null) {
      byte noteinlastchord[] = new byte[12];
      for (int i = 0;i < 12;i++){noteinlastchord[i] = 0;}
      for (int i2 = 0;i2 < 4;i2++) {
        noteinlastchord[chordnotesc.chords[last_chord.type][i2] % 12] = 1;
      }    
      for (int i = 0;i < 4;i++) {
        if (noteinlastchord[chordnotesc.chords[t][i] % 12] == 0){
          s = s + 1;
        }
      }
    }
    return s;
  }
  void addchordstonotes() {
    int i = 0;
    while ((i+4) < size()) {
      cachord c = getbestchord(i);
      if (last_chord != null) {c.selectbestoctave(last_chord);}
      last_chord = c;
      canote n = (canote) get(i);
      n.c = c;
      i = i + c.length;
    }
  }
  cachord getbestchord(int offset){
      int bestscore = 0;
      int bestchord = 0;
      for (int i = 0;i < chordnotesc.numchords;i++) {
        chordnotesc.chordindex[i] = i;
      }
      for (int i = 0;i < chordnotesc.numchords;i++) {
        int j = cellautoapp.rand2.nextInt(i+1);
        int tmp = chordnotesc.chordindex[i];
        chordnotesc.chordindex[i] = chordnotesc.chordindex[j];
        chordnotesc.chordindex[j] = tmp;
      }
      for (int i = 0;i < chordnotesc.numchords;i++) {
        int i2 = chordnotesc.chordindex[i];
        int chordscore = getchordscore(offset,i2);
        if (chordscore > bestscore) {
          bestscore = chordscore;
          bestchord = i2;
        }
      }
      int l = 0;
      for (int i = 0;i < 4;i++) {
        canote n = (canote) get(i+offset);
        l = l + n.length;
      }
      return new cachord(bestchord,4,l);
    
  }
}
class xm_patternc {
  int num_rows;
  int num_channels;
  canote note[][];
  
  xm_patternc(int num_channels,int num_rows) {
    note = new canote[num_channels][num_rows];
    this.num_rows = num_rows;
    this.num_channels = num_channels;
  }
  canote read_note(int channel,int row) {
    return note[channel][row];
  }
  void write_note(int channel,int row,canote n) {
    note[channel][row] = n;
  }
  int get_num_notes() {
    int n = 0;
    for (int y = 0;y < num_rows;y++) {
      for (int x = 0;x < num_channels;x++) {
        if (note[x][y] != null) {
          n++;
        }
      }
    }
    return n;
  }
  void output_pattern(DataOutputStream o) {
    try {
      int num_notes = get_num_notes();
      //System.out.println("num notes: " + num_notes);
      o.writeInt(note_playerc.swapbytesofint(9));
      o.writeByte(0);
      o.writeShort(note_playerc.swapbytesofword(num_rows));
      o.writeShort(note_playerc.swapbytesofword((num_rows*num_channels) + (num_notes * 3)));
      for (int y = 0;y < num_rows;y++) {
        for (int x = 0;x < num_channels;x++) {
          canote n = note[x][y];
          if (n == null) {
            o.writeByte(128);
          } else {
            o.writeByte(128 + 7);
            int freq2 = n.freq-12+1 + cellautoapp.key_to_play_in;
            while (freq2 > 96) {freq2 = freq2 - 12;}
            while (freq2 < 1) {freq2 = freq2 + 12;}
            o.writeByte(freq2);
            o.writeByte(n.ins);
            o.writeByte(0);
          }
        }
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}


class note_playerc implements MetaEventListener{
  Sequencer seqr;
  
  note_playerc() {
    initSequencer();
  }
  void initSequencer() {
      try {
        seqr = MidiSystem.getSequencer();
        seqr.addMetaEventListener(this);
        seqr.open();
        if (! (seqr instanceof Synthesizer)) {
          try {
	    Synthesizer sn = MidiSystem.getSynthesizer();
	    sn.open();
	    Receiver r = sn.getReceiver();
	    Transmitter t = seqr.getTransmitter();
	    t.setReceiver(r);            
          } catch (MidiUnavailableException e) {
	    e.printStackTrace();
          }
        }
      } catch (Exception e) {
        e.printStackTrace();
      }
  }
  public void meta(MetaMessage event){
    if (event.getType() == 47) {
      //System.out.println("done");
      cellautoapp.songisdone();
    }
  }

  void stop() {
    seqr.stop();
  }
  Sequence get_sequence_form_notelist(notelistc l,int tempo) {
    long p = 0;
    try {
      Sequence seq = new Sequence(Sequence.PPQ, tempo);
      int numnotes = cellautoapp.cellauto131.numcolors-1;
      chordnotesc.numchords = 7+((numnotes-7)*4);
      Track t = seq.createTrack();    
      Track t2 = seq.createTrack();    
      select_instrument(t,0,cellautoapp.melody_instrument);
      select_instrument(t2,1,cellautoapp.chord_instrument);
      int o = 0;
      if (cellautoapp.play_octaves == cellautoapp.UPPER_OCTAVE){
        o = 12;
      }
      //System.out.println("num notes at a time: " + cellautoapp.num_notes_at_a_time);
      for (int i = 0;i < l.size();i++) {
        canote n = (canote) l.get(i);
        int l2 = l.getnoteindexlength(i,cellautoapp.num_notes_at_a_time);
        if (cellautoapp.play_octaves == cellautoapp.BOTH_OCTAVES){
          o = (o + 12) % 24;
        }
        playnote(t,0,n.freq+o,l2,n.am,p);
        //System.out.println("note: " + n.getname());
        if (n.c != null) {
          //System.out.println("chord: " + n.c.getname());
          playnote(t2,1,chordnotesc.chords[n.c.type][0]-24+(n.c.octave*12),n.c.length2,cellautoapp.chord_volume,p);
          playnote(t2,1,chordnotesc.chords[n.c.type][1]-12+(n.c.octave*12),n.c.length2,cellautoapp.chord_volume,p);
          playnote(t2,1,chordnotesc.chords[n.c.type][2]-12+(n.c.octave*12),n.c.length2,cellautoapp.chord_volume,p);
          playnote(t2,1,chordnotesc.chords[n.c.type][3]+(n.c.octave*12),n.c.length2,cellautoapp.chord_volume,p);
        }
        p = p + n.length;
      }
      return seq;
    } catch (Exception e) {
      e.printStackTrace();
    }
    return null;
  }
  void playnotelist(notelistc l,int tempo) {
    try {
      Sequence seq = get_sequence_form_notelist(l,tempo);
      play_Sequence(seq);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  void play_Sequence(Sequence seq) {
    try {
      seqr.setSequence(seq);
      seqr.start();	
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  void stop_Sequencer() {
    try {
      seqr.stop();	
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  void write_fixed_length_string(DataOutputStream o,String str,int l) {
    try {
      int l2 = str.length();
      for (int i = 0;i < l;i++){
        byte b = (byte) str.charAt(i);
        if (i < l2) {
          o.writeByte(b);
        } else {
          o.writeByte(0);
        }
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  static int swapbytesofword(int n) {
    return (((n >> 8) & 255) | ((n & 255) << 8));
  }
  static int swapbytesofint(int n) {
    return (((n >> 24) & 255) << 0) | (((n >> 16) & 255) << 8) |
    (((n >> 8) & 255) << 16) | (((n >> 0) & 255) << 24);
  }

  void output_notelist_to_xm_file(notelistc l,File f,int tempo) {
    int patternrows = 256;
    int oct = 0;
    int ch_pos = 0;
    int num_notes_at_a_time = cellautoapp.num_notes_at_a_time;
    if (cellautoapp.play_octaves == cellautoapp.UPPER_OCTAVE){
      oct = 12;
    }
    try {
      DataOutputStream o = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(f,true)));
      Vector v = new Vector();
      int p = 0;
      for (int i = 0;i < l.size();i++) {
        canote n = (canote) l.get(i);
        p = p + n.length;
        int i2 = p / patternrows;
        xm_patternc pat = null;
        if (i2 >= v.size()) {
          pat = new xm_patternc(num_notes_at_a_time+4,patternrows);
          v.add(pat);
        }
        pat = (xm_patternc) v.get(i2);
        n.ins = 1;
        if (cellautoapp.play_octaves == cellautoapp.BOTH_OCTAVES){
          oct = (oct + 12) % 24;
        }
        n.freq = n.freq + oct;
        pat.write_note((i % num_notes_at_a_time),p % patternrows,n);
        n.freq = n.freq - oct;
        canote n2;
        if (n.c != null) {
          int o2[] = new int[4];
          o2[0] = 24;
          o2[1] = 12;
          o2[2] = 12;
          o2[3] = 0;
          n2 = new canote(0,1);
          for (int i3 = 0;i3 < 4;i3++) {
            n2 = new canote(chordnotesc.chords[n.c.type][i3]-o2[i3]+(n.c.octave*12),1);
            n2.ins = 2;
            pat.write_note(i3+num_notes_at_a_time,p % patternrows,n2);
          }
        }
      }

      o.writeBytes("Extended module: ");
      o.writeBytes("CAMusic song        ");
      o.writeByte(0x1a);
      o.writeBytes("CAMusic program     ");
      o.writeShort(swapbytesofword(0x103));
      o.writeInt(swapbytesofint(256+20));
      int songlength = v.size();
      if (songlength > 256) {songlength = 256;} 
      o.writeShort(swapbytesofword(songlength));
      o.writeShort(swapbytesofword(0));
      o.writeShort(swapbytesofword(num_notes_at_a_time+4));
      o.writeShort(swapbytesofword(v.size()));
      o.writeShort(swapbytesofword(0));
      o.writeShort(swapbytesofword(1));
      o.writeShort(swapbytesofword(125));
      o.writeShort(swapbytesofword(6));
      for (int i = 0;i < 256;i++) {
        o.writeByte(i);
      }

      for (int i = 0;i < v.size();i++) {
        xm_patternc pat = (xm_patternc) v.get(i);
        pat.output_pattern(o);
      }
      o.writeByte(0);
      o.writeByte(0);
      o.writeByte(0);
      o.writeByte(0);
      
      o.close();
    } catch (Exception e) {
      e.printStackTrace();
    }
    
  }
  void output_notelist_to_file(notelistc l,File f,int tempo) {
    try {
    Sequence seq = get_sequence_form_notelist(l,tempo);
    MidiSystem.write(seq, 1, f);  
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  void select_instrument(Track t,int c,int i) {
    try {
      ShortMessage m = new ShortMessage();
      m.setMessage(ShortMessage.PROGRAM_CHANGE,c,i-1,0);
      t.add(new MidiEvent(m,0));
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  void playnote(Track t,int c, int freq,int length,int am, long p) {
    try {
      int freq2 = freq + cellautoapp.key_to_play_in;
      while (freq2 > 127) {freq2 = freq2 - 12;}
      while (freq2 < 0) {freq2 = freq2 + 12;}
      ShortMessage m = new ShortMessage();
      m.setMessage(ShortMessage.NOTE_ON,c,freq2,am);
      t.add(new MidiEvent(m,p));
      ShortMessage m2 = new ShortMessage();
      m2.setMessage(ShortMessage.NOTE_OFF,c,freq2,0);
      t.add(new MidiEvent(m2,p+length));
    } catch (Exception e) {
      e.printStackTrace();
    }
    
  }
  void playnoteonkeyboard(int n) {
	try {
          int n2 = n + cellautoapp.key_to_play_in;
          if (n2 > 127) {n2 = n2 - 12;}
          if (n2 < 0) {n2 = n2 + 12;}
	  Sequence seq = new Sequence(Sequence.PPQ, 1);
          Track	track = seq.createTrack();    
          select_instrument(track,0,cellautoapp.melody_instrument);
          playnote(track,0,n,4,80,0);          
          seqr.setSequence(seq);
          seqr.start();	
        } catch (Exception e) {
		e.printStackTrace();
	}

   }
}

